<?php

require_once(NEXTEND_ACCORDION_MENU . 'library' . DIRECTORY_SEPARATOR . 'accordionmenu' . DIRECTORY_SEPARATOR . 'wordpress' . DIRECTORY_SEPARATOR . 'treebase.php');

class NextendTreeWooCommerce extends NextendTreebaseWordpress
{

    var $items = array();
    var $all = array();
    var $order = array();

    function NextendTreeWooCommerce(&$menu, &$module, &$data) {
        parent::__construct($menu, $module, $data);
        $this->initConfig();
    }

    function initConfig() {
        parent::initConfig();
        $this->initMenuicon();
    }

    function createTree(&$list, &$new, $parent) {
        if (isset($new[$parent])) {
            for ($i = 0; $i < count($new[$parent]); $i++) {
                $list[] = $new[$parent][$i];
                $this->createTree($list, $new, $new[$parent][$i]->cat_ID);
            }
        }
        return $list;
    }

    function getCatImage($cat_term_id) {
        $thumbnail_id = get_woocommerce_term_meta($cat_term_id, 'thumbnail_id', true);
        $image        = wp_get_attachment_url($thumbnail_id);
        if ($image) {
            return $image;
        } else {
            return null;
        }
    }

    function getAll($menus, $parent = false) {
        $newMenus = array();
        foreach ($menus AS $m) {
            if (!$parent || ($parent && $m != 0)) {
                if (!$parent) {
                    $args = array(
                        'hide_empty' => 0,
                        'parent'     => $m,
                        'taxonomy'   => 'product_cat'
                    );
                } else {
                    $args = array(
                        'hide_empty' => 0,
                        'include'    => $m,
                        'taxonomy'   => 'product_cat'
                    );
                }
                if ($this->order[0] == 'title') {
                    $args += array(
                        'orderby' => 'title',
                        'order'   => $this->order[1]
                    );
                } else {
                    $args += array(
                        'menu_order' => $this->order[1]
                    );
                }

                if ($this->order[0] == 'title') {
                    $args += array(
                        'orderby' => 'title',
                        'order'   => $this->order[1]
                    );
                } else {
                    $args += array(
                        'menu_order' => $this->order[1]
                    );
                }
                $subCats = get_categories($args);
                for ($i = 0; $i < count($subCats); $i++) {
                    $subCats[$i]->id    = $newMenus[] = $subCats[$i]->term_id;
                    $subCats[$i]->title = $subCats[$i]->name;
                    if ($parent) {
                        $subCats[$i]->parent = 0;
                    }
                }
                $this->all = array_merge($this->all, $subCats);
            }
            if (!empty($newMenus) && !$parent) {
                $this->getAll($newMenus);
            }
        }
    }

    function getAllItems() {
        $menus        = explode("||", $this->_data->get('woocommercemenu', '0'));
        $root         = $this->_data->get('wooroot', '0');
        $onlySelected = explode("|*|", $this->_data->get('onlyselected', '0|*|1|*|1'));
        $this->order  = explode("|*|", $this->_data->get('category_order', 'name'));
        $removeFrom   = explode("||", $this->_data->get('wooremove', ''));;
        if ($removeFrom[0] == 0 || $removeFrom[0] == '' || empty($removeFrom)) {
            $remove = false;
        } else {
            $remove = true;
        }
        $options = array();

        if (!$onlySelected[0]) {
            $this->getAll($menus);
            if ($root) {
                $this->getAll($menus, true);
            }
            $items = $this->all;
        } else {
            $args    = array(
                'order'        => $this->order[1],
                'order'        => 'ASC',
                'hide_empty'   => 0,
                'hierarchical' => 1,
                'exclude'      => '',
                'include'      => $menus,
                'number'       => '',
                'taxonomy'     => 'product_cat',
                'pad_counts'   => false
            );
            if($this->order == "title"){
                $args['orderby'] = "name";
            }
            $options = get_categories($args);
        }

        if (!$onlySelected[0]) {
            $new = array();
            foreach ($items as $a) {
                $new[$a->parent][] = $a;
            }
            $list = array();
            if (!$root) {
                foreach ($menus AS $menu) {
                    $options += $this->createTree($list, $new, $menu);
                }
            } else {
                $options = $this->createTree($list, $new, 0);
            }
        } else {
            for ($i = 0; $i < count($options); $i++) {
                $options[$i]->id       = new stdClass();
                $options[$i]->title    = new stdClass();
                $options[$i]->treename = new stdClass();
                $options[$i]->id       = $options[$i]->term_id;
                $options[$i]->title    = $options[$i]->name;
                $options[$i]->treename = $options[$i]->name;
            }
        }

        for ($i = 0; $i < count($options); $i++) {
            if ($options[$i] != null) {
                if ($remove) {
                    if (in_array($options[$i]->id, $removeFrom)) {
                        break;
                    }
                }
                $allItems[$options[$i]->id] = $options[$i];
                if (!$onlySelected[0]) {
                    if (!$root && in_array($options[$i]->parent, $menus)) {
                        $allItems[$options[$i]->id]->parent = 0;
                    }
                } else {
                    if (!$onlySelected[1]) {
                        $allItems[$options[$i]->id]->parent = 0;
                    } else {
                        if (!in_array($options[$i]->parent, $menus)) {
                            $allItems[$options[$i]->id]->parent = 0;
                        }
                    }
                }
            }
        }

        return $allItems;
    }

    function getActiveItem() {
        $this->active = null;
        $this->active = new StdClass;
        global $wp_query;
        if (!is_product() && isset($wp_query->query_vars['product_cat'])) {
            $category_slug   = $wp_query->query_vars['product_cat'];
            $category_object = get_term_by('slug', $category_slug, 'product_cat');
            $page_id         = $category_object->term_id;
        } else {
            $activeElements = $this->_data->get('activeelements', '0');
            if ($activeElements != '0') {
                $product = $wp_query->get_queried_object();
                if ($product) {
                    $id   = $product->ID;
                    $cats = wp_get_post_terms($id, 'product_cat', array(
                        'fields'  => 'ids',
                        'orderby' => 'term_id',
                        'order'   => 'ASC'
                    ));
                    if (!empty($cats)) {
                        switch ($activeElements) {
                            case 1:
                                $page_id = $cats[0];
                                break;
                            case 2:
                                $page_id = end($cats);
                                break;
                        }
                    } else {
                        $page_id = null;
                    }

                    if (!in_array($page_id, $this->items) && !empty($cats)) {
                        foreach ($cats AS $cat) {
                            if (in_array($cat, $this->items)) {
                                $page_id = $cat;
                            }
                        }
                    }
                } else {
                    $page_id = null;
                }
            } else {
                $page_id = null;
            }
        }
        $this->active->id = $page_id;
        return $this->active;
    }

    function find_active($sorted_menu_items) {
        foreach ($sorted_menu_items as $menu_item) {
            if ($menu_item->current) {
                $active         = new stdClass();
                $active->id     = $menu_item->id;
                $active->parent = $menu_item->parent;
                $this->active   = $active;
                break;
            }
        }
        return $sorted_menu_items;
    }

    function getItemsTree() {
        return $this->getItems();
    }

    function filterItem($item) {

        if ($item->classes != null) $item->classes = implode(' ', $item->classes);

        $item->nname = '<span>' . $item->title . '</span>';

        if ($this->_config['menuiconshow'] && $this->getCatImage($item->id) != null) {
            $this->parseIcon($item, $this->getCatImage($item->id), '');
        }

        if ($this->_config['displaynum'] != 0 && $item->count != 0) {
            $item->nname = $this->renderProductnum($item->count) . $item->nname;
        }

        if (!$this->_config['parentlink'] && $item->p) {
            $item->nname = '<a>' . $item->nname . '</a>';
        } else {
            $item->nname = '<a href="' . get_term_link($item->slug, 'product_cat') . '">' . $item->nname . '</a>';
        }
    }

}

?>